Subject: bug#39118: Segfault while building on 64-bit Cygwin

From: Mike Gran <[email-masked]>
Date: Sun, 16 Feb 2020 15:23:34 -0800

On Fri, Feb 14, 2020 at 09:46:04AM -0800, Charles Stanhope wrote:
> Andy, I don't know if you'd want to continue this here or on
> lightening's gitlab page, but I looked into this a little bit a few
> minutes here and there this past weeek. The x86 "fast-call" calling
> convention used on Windows x64[0] and shared by Cygwin[1] requires
> that the caller reserve 32 bytes of memory on the stack for the callee
> to spill the register parameters (even if the callee takes fewer than
> four parameters). I think lightening is currently missing that for the
> x64 case for Cygwin.
> 
> To test the idea, I made a small modification (patch attached) that is
> *not* intended as a solution as it doesn't work for the general case,
> but it does allow the tests to pass on Cygwin 64.

I can confirm that Charles's patch, plus another one line patch
to define CPU_SETSIZE, is enough to get Guile 3.0.x to build and run
on my box.  All tests pass except strptime in French, and the absence
of crypt.  This is a 64-bit build.

-Mike Gran